#include <hmg.ch>

DECLARE WINDOW frmPPTFile

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

/*

   Print a plain text file (express way).
   
   Return : Printed page count
   
*/

FUNCTION  PPTFExpr(;                     // Print plain text file, Express
                    cPLTFName )
                    
   LOCAL cFontName := "Lucida Console",; 
         nFontSize := 10   

   LOCAL lSuccess,;
         aPTFLines,;
         c1Line,;
         nChrsPerLin := 80,; // tecriben; yersen !
         nEndOfLine  := 200,;
         nLineHeigth := 5,; // keza !
         nSubLinCo,;
         nVMargin  := 20,;    // Vertical margin
         nHMargin  := 20    // Horizontal margin         

   LOCAL nPrintRow := nVMargin,;
         nPrintCol := nHMargin,;
         nPageLimit := 297 - nVMargin
       
   LOCAL nPageCount := 1       
   
   aPTFLines := HB_ATOKENS( HB_MEMOREAD( cPLTFName ), CRLF )
   
   IF ! EMPTY( aPTFLines )    
   
      SELECT PRINTER DEFAULT TO lSuccess

      IF lSuccess
         START PRINTDOC 
            START PRINTPAGE
               FOR EACH c1Line IN aPTFLines
               
                  c1Line := STRTRAN( c1Line, CHR( 9 ), "   " )
                  
                  c1Line := SpliteLines( c1Line, nChrsPerLin )
                     
                  nSubLinCo := HB_TOKENCOUNT( c1Line, CRLF )  
                  
                  IF nPrintRow + nLineHeigth * nSubLinCo > nPageLimit                  
                     END PRINTPAGE
                     ++nPageCount 
                     nPrintRow := nVMargin
                     START PRINTPAGE
                  ENDIF   
                  
                  @ nPrintRow, nPrintCol PRINT c1Line ;
                                        TO nPrintRow + nLineHeigth * nSubLinCo, nEndOfLine ;
                                        FONT cFontName SIZE nFontSize 
                                        
                  nPrintRow += nLineHeigth * nSubLinCo
                  
                  DO EVENTS
                  
               NEXT c1Line 
            END PRINTPAGE             
         END PRINTDOC
      ENDIF lSuccess

   ENDIF ! EMPTY( aPTFLines )    
   
RETURN  nPageCount // PPTFExpr()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.

FUNCTION SpliteLines( ;                   // Splite a line to given portions without split last word
                     cLine,;
                     nLeng ) // in char
                     
   LOCAL cRVal  := '',;
         c1Line := '',;
         nTknPos := 0     // Last token position  
         
   WHILE LEN( cLine ) > nLeng
      c1Line := LEFT( cLine, nLeng ) 
      nTknPos := AtToken( c1Line ) // RAT( ' ', c1Line ) 
      IF nTknPos > 1      
         c1Line :=  LEFT( c1Line, nTknPos -1 ) 
      ENDIF      
      cRVal += c1Line + CRLF      
      cLine := SUBSTR( cLine,  LEN( c1Line ) + 1 )
   ENDDO
   
   IF !EMPTY( cLine )
      cRVal += cLine // + CRLF
   ENDIF
   
RETURN cRVal // SpliteLines()

*-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.
